/*-------------------------*
 | Directory Stack for DOS |-+
 |      Version 2.00       | |      Copyright (c) 1993, 1997, 1998
 *-------------------------* |                      by altair@m4.people.or.jp
   +-------------------------*/
#include<dos.h>
#include<dir.h>
#include<process.h>
#include<stdio.h>
#include"dirstack.h"

struct option option={0,0,0,0};

char stack[MAXSTACK][MAXPATH];
int depth=-1;

void getstack(void)
{   char*cp,far*fcp;

    depth=1;
    fnslashify(getcwd(*stack,MAXPATH));
    _chkinst();
    if(!resident)
        return;

    for(fcp=MK_FP(resident,peek(resident,TRANSIENT));*fcp;++fcp)
    {   for(cp=stack[depth++];*fcp!=';';)
            *cp++=*fcp++;
        *cp=0;
    }
}

void dirs(void)
{   int i;

    getstack();

    for(i=0;i<depth;++i)
        if(option.v)
            printf("%i\t%s\n",i,stack[i]);
        else
            printf("%s ",stack[i]);

    if(!option.v)
        putchar('\n');
}

int _plvn(int c,const char*version)
{   switch(c)
    {   case'v':    option.v=1;
                    break;

        case'n':    option.n=1;
                    break;

        case'l':    option.l=1;
                    break;

        case'p':    option.p=1;
                    break;

        case'V':    printf("%s: Version %s by altair@m4.people.or.jp\n",
                           caller,version);
                    exit(0);

        default:    return 0;
    }
    return 1;
}

int plvn(int c,const char*version)
{   int rc;

    option.p|=rc=_plvn(c,version);
    return rc;
}
