/*-------------------------*
 | Directory Stack for DOS |-+
 |      Version 2.00       | |      Copyright (c) 1993, 1997, 1998
 *-------------------------* |                      by altair@m4.people.or.jp
   +-------------------------*/
#include<dos.h>
#include<process.h>
#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include"dirstack.h"

char*caller="popd",newstack[MAXPATH*MAXSTACK]="";

static void concat(int i,int z)
{   for(;i<depth;++i)
        if(i!=z)
        {   if(strlen(newstack)+strlen(stack[i])+1>peek(resident,STSIZE))
                break;
            strcat(strcat(newstack,stack[i]),";");
        }
}

int main(int argc,char**argv)
{   int rc=1,n=0;

    while(--argc>0)
        switch(**++argv)
        {   case'-':    ++*argv;
                        do
                            if(!plvn(**argv,VERSION))
                            {   rc=**argv!='h';
                                goto u;
                            }
                        while(*++*argv);
                        break;

            case'+':    for(n=0;*++*argv;)
                        {   if(!isdigit(**argv))
                                goto u;

                            n=n*10+**argv-'0';
                        }
                        if(!n||argc>1){
u:          default:        fputs("Usage: popd [-plvn] [+<n>]\n",
                                  rc?stderr:stdout);
                            return rc;
                        }
        }

    chkinst();
    getstack();

    if(n)
    {   if(n>=depth)
        {   puts("pushd: Directory stack not that deep.");
            return 1;
        }
        concat(1,n);
    }else
    {   cdd(stack[1]);
        concat(2,0);
    }
    _fstrcpy(MK_FP(resident,peek(resident,TRANSIENT)),newstack);

    if(option.p||!peekb(resident,PUSHDSILENT))
        dirs();

    return 0;
}
