/*-------------------------*
 | Directory Stack for DOS |-+
 |      Version 2.00       | |      Copyright (c) 1993, 1997, 1998
 *-------------------------* |                      by altair@m4.people.or.jp
   +-------------------------*/
#include<dos.h>
#include<dir.h>
#include<alloc.h>
#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include"dirstack.h"

struct flags far*flagsp;

char*caller="pushd";
int dextract;

static char*rotate(int n)
{   int i;

    if(dextract)
        join(1,depth,n);
    else
        if(join(n+1,depth,-1))
            join(0,n,-1);

    return stack[n];
}

int main(int argc,char**argv)
{   char*target;
    int rc=1,n=0;

    while(--argc>0)
        switch(**++argv)
        {   case'-':    if(!*++*argv)
                        {   chkinst();
                            if(!(target=malloc(MAXPATH)))
                            {   perror(caller);
                                return 1;
                            }
                            _fstrcpy(target,MK_FP(resident,LASTDIR));
                            goto chkargc;
                        }
                        do
                            if(!plvn(**argv,VERSION))
                            {   rc=**argv!='h';
                                goto u;
                            }
                        while(*++*argv);
                        break;

            case'+':    target=*argv;
                        for(n=0;*++*argv;)
                        {   if(!isdigit(**argv))
                            {   n=0;
                                break;
                            }
                            n=n*10+**argv-'0';
                        }
                        goto chkargc;

            default:    target=*argv;
                        goto chkargc;
        }

chkargc:
    chkinst();
    dextract=peekb(resident,DEXTRACT);

    switch(argc)
    {   case 0:     dextract=n=1;
        case 1:     break;
        default:
u:                  fputs("Usage: pushd [-plvn] [-|<dir>|+<n>]\n",
                          rc?stderr:stdout);
                    return rc;
    }
    getstack();
    if(n)
    {   if(n>=depth)
        {   puts("pushd: Directory stack not that deep.");
            return 1;
        }
        target=rotate(n);
    }else
        join(0,depth,-1);

    cdd(target);
    _fstrcpy(MK_FP(resident,peek(resident,TRANSIENT)),newstack);

    if(option.p||!peekb(resident,PUSHDSILENT))
        dirs();

    return 0;
}
